Imports System.Runtime.InteropServices
Imports System.ComponentModel


' IOleWindow interface
<ComVisible(True), ComImport(), Guid("00000114-0000-0000-C000-000000000046"), _
InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)> _
Public Interface IOleWindow
    Sub GetWindow(ByRef phwnd As IntPtr)
    Sub ContextSensitiveHelp(ByVal fEnterMode As Boolean)
End Interface

Public Class Utils

    Public Shared Function GetExplorerWindowHandle(ByVal explorer As Object) As IntPtr
        If (explorer Is Nothing) Then
            Return IntPtr.Zero
        End If

        Dim IWin As IOleWindow = Nothing
        IWin = TryCast(explorer, IOleWindow)

        If IWin IsNot Nothing Then
            Dim Handle As IntPtr = IntPtr.Zero
            IWin.GetWindow(Handle)
            Return Handle
        End If

        Return IntPtr.Zero
    End Function

    Public Shared Function GetActiveExplorer(ByVal outlookApp As Object) As Object
        If outlookApp IsNot Nothing Then
            Return outlookApp.GetType().InvokeMember("ActiveExplorer", Reflection.BindingFlags.GetProperty, Nothing, outlookApp, New Object() {})
        End If
        Return Nothing
    End Function
End Class
